var generators = require('yeoman-generator');
var chalk      = require('chalk');
var fs         = require('fs');
var path       = require('path');


module.exports = generators.Base.extend({
  initializing: function() {
    this.conflicter.force = true
  },
  prompting: function() {
    var done = this.async();

    var prompts = [{
      type: 'list',
      name: 'graphql-mock-server',
      message: 'Do you want to use GraphQl mock-server?',
      choices: [
        'Yes',
        'No'
      ]
    }];

    this.prompt(prompts, function(answers) {
      this.props = answers;
      done();
    }.bind(this));
  },
  configuring: function() {
    if (this.props['graphql-mock-server'] === 'No'|| !this.props['graphql-mock-server']) return;

    // Generate our package.json. Make sure to also include the required dependencies for styles
    var scripts = {};

    var packageSettings = {
      name: 'graphql-mock-server',
      private: true,
      version: '0.1.0',
      description: 'Generated by generator-jetreact',
      main: 'server.js',
      scripts: scripts,
      repository: '',
      keywords: [],
      author: 'Alex Khrustalev',
    };

    this.fs.writeJSON(this.destinationPath('graphql-mock-server/package.json'), packageSettings);
  },
  writing: function() {
    if (this.props['graphql-mock-server'] === 'No'|| !this.props['graphql-mock-server']) return;

    var baseTemplatePath = this.templatePath('graphql-mock-server-skeleton');

    // Get all files in our repo and copy the ones we should
    fs.readdir(baseTemplatePath, (err, items) => {
      for(var item of items) {
        var fullPath = path.join(baseTemplatePath, item);

        // Copy all items to our root
        if(fs.lstatSync(fullPath).isDirectory()) {
          this.bulkDirectory(path.join('graphql-mock-server-skeleton', item), item);
        } else {
          this.copy(path.join('graphql-mock-server-skeleton', item), item);
        }
      }
    });
  },
  install: function() {
    if (this.props['graphql-mock-server'] === 'No'|| !this.props['graphql-mock-server']) return;

    var dependencies = [
      'install',
      '--save',

      'body-parser',
      'cors',
      'express',
      'graphql',
      'graphql-server-express',
      'morgan'
    ];

    this.spawnCommand('npm', dependencies, { cwd: this.destinationPath('graphql-mock-server')});
  }
});